import { B as BaseTypeTableProps, G as GenerateDocumentationOptions } from '../type-table-DyymKQK8.js';
import { ReactNode } from 'react';
import 'ts-morph';

interface AutoTypeTableProps extends BaseTypeTableProps {
    /**
     * Override the function to render markdown into JSX nodes
     */
    renderMarkdown?: typeof renderMarkdownDefault;
}
declare function createTypeTable(options?: GenerateDocumentationOptions): {
    AutoTypeTable: (props: Omit<AutoTypeTableProps, 'options'>) => ReactNode;
};
/**
 * **Server Component Only**
 *
 * Display properties in an exported interface via Type Table
 */
declare function AutoTypeTable({ renderMarkdown, ...props }: AutoTypeTableProps): Promise<ReactNode>;
declare function renderMarkdownDefault(md: string): Promise<ReactNode>;

export { AutoTypeTable, type AutoTypeTableProps, createTypeTable };
