import {
  __async,
  __objRest,
  __spreadProps,
  __spreadValues,
  getProject,
  getTypeTableOutput,
  renderMarkdownToHast
} from "../chunk-LRCT2FYJ.js";

// src/ui/auto-type-table.tsx
import { TypeTable } from "fumadocs-ui/components/type-table";
import { toJsxRuntime } from "hast-util-to-jsx-runtime";
import * as runtime from "react/jsx-runtime";
import defaultMdxComponents from "fumadocs-ui/mdx";
import "server-only";
import { jsx as jsx2 } from "react/jsx-runtime";
function createTypeTable(options = {}) {
  var _a;
  const overrideOptions = __spreadProps(__spreadValues({}, options), {
    project: (_a = options.project) != null ? _a : getProject(options.config)
  });
  return {
    AutoTypeTable(props) {
      return /* @__PURE__ */ jsx2(AutoTypeTable, __spreadProps(__spreadValues({}, props), { options: overrideOptions }));
    }
  };
}
function AutoTypeTable(_a) {
  return __async(this, null, function* () {
    var _b = _a, {
      renderMarkdown = renderMarkdownDefault
    } = _b, props = __objRest(_b, [
      "renderMarkdown"
    ]);
    const output = yield getTypeTableOutput(props);
    return output.map((item) => __async(this, null, function* () {
      const entries = item.entries.map(
        (entry) => __async(this, null, function* () {
          return [
            entry.name,
            {
              type: entry.type,
              description: yield renderMarkdown(entry.description),
              default: entry.tags.default || entry.tags.defaultValue,
              required: entry.required
            }
          ];
        })
      );
      return /* @__PURE__ */ jsx2(
        TypeTable,
        {
          type: Object.fromEntries(yield Promise.all(entries))
        },
        item.name
      );
    }));
  });
}
function renderMarkdownDefault(md) {
  return __async(this, null, function* () {
    return toJsxRuntime(yield renderMarkdownToHast(md), {
      Fragment: runtime.Fragment,
      jsx: runtime.jsx,
      jsxs: runtime.jsxs,
      components: __spreadProps(__spreadValues({}, defaultMdxComponents), { img: void 0 })
    });
  });
}
export {
  AutoTypeTable,
  createTypeTable
};
